local E, L, V, P, G, _ = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB, Localize Underscore

local i = 0

ElvUF.Tags.Events['GroupNumber'] = 'GROUP_ROSTER_UPDATE'
ElvUF.Tags.Methods['GroupNumber'] = function(unit)
	if IsInRaid() then
		for i = 1, GetNumGroupMembers() do
			local name, _, subgroup = GetRaidRosterInfo(i)
			if name == UnitName(unit) then
				return subgroup
			end
		end
	end
end

ElvUF.Tags.Events['GroupNumberText'] = 'GROUP_ROSTER_UPDATE'
ElvUF.Tags.Methods['GroupNumberText'] = function(unit)
	if IsInRaid() then
		for i = 1, GetNumGroupMembers() do
			local name, _, subgroup = GetRaidRosterInfo(i)
			if name == UnitName(unit) then
				return format('Gruppe: %d', subgroup)
			end
		end
	end
end

ElvUF.Tags.Events['MaRassColor'] = "UNIT_CLASSIFICATION_CHANGED"
ElvUF.Tags.Methods['MaRassColor'] = function(u)
	local r, g, b = 1, 1, 1
	
		local c = UnitClassification(u)
		if(c == 'rare') then
			r, g, b = 0.6, 0.8, 0.8
		elseif(c == 'eliterare') then
			r, g, b = 0.5, 0.8, 1
		elseif(c == 'elite') then
			r, g, b = 1, 0.4, 0.2
		elseif(c == 'worldboss') then
			r, g, b = 1, 0.2, 0
		end 
		
	return Hex(r,g,b)
end

ElvUF.Tags.Events['MaClassification'] = "UNIT_CLASSIFICATION_CHANGED"
ElvUF.Tags.Methods['MaClassification'] = function(u)
	local c = UnitClassification(u)
	local t = ''
		if c == 'worldboss' then
			t = 'Boss'			
		elseif c == 'elite' then
			t = 'Elite'						
		elseif c == 'rare' then
			t ='Rare'				
		elseif c == 'rareelite' then
			t = 'Rare Elite'	
		elseif c ~= 'normal' and c ~= 'minus' then
			t = ''	
		end
		
	return t
end

ElvUF.Tags.Events['MaNameStatus'] = 'UNIT_HEALTH_FREQUENT UNIT_MAXHEALTH UNIT_CONNECTION PLAYER_FLAGS_CHANGED UNIT_NAME_UPDATE'
ElvUF.Tags.Methods['MaNameStatus'] = function(unit)
	local status = UnitIsDead(unit) and DEAD or UnitIsGhost(unit) and L['Ghost'] or not UnitIsConnected(unit) and L['Offline']
	local name = UnitName(unit)
	if (status) then
		return status
	else
		return name ~= nil and E:ShortenString(name, 15) or ''
	end
end
